<template>
  <v-container>
    <v-row>
      <v-col cols="12">
        <v-card>
          <v-toolbar color="secondary" dense>
            <v-toolbar-title>Создать заявку</v-toolbar-title>
          </v-toolbar>
          <v-card-text>
            <v-row>
              <v-col cols="12" v-if="selectedConsultation">
                <div class="white--text" v-html="selectedConsultation.content.description"></div>
              </v-col>
              <v-col cols="12">
                <v-select
                  v-model="selectedConsultation"
                  label="Консультация"
                  outlined
                  hide-details
                  :items="consultations"
                  return-object
                  item-text="content.name"
                  :value="consultationId"
                />
              </v-col>
              <v-col cols="12">
                <v-text-field
                  label="Стоимость"
                  outlined
                  hide-details
                  disabled
                  :value="`${price} рублей`"
                />
              </v-col>
              <v-col cols="12">
                <v-textarea
                  outlined
                  label="Описание вашей ситуации"
                  v-model="description"
                  rows="8"
                  hide-details
                />
              </v-col>
              <v-col cols="12">
                <v-btn block color="primary" @click="send" :disabled="!selectedConsultation">
                  {{ selectedConsultation ? 'Отправить' : 'Выберите консультацию' }}
                </v-btn>
              </v-col>
            </v-row>
          </v-card-text>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">

import Vue from "vue";
import Component from "vue-class-component";
import { Prop } from "vue-property-decorator";
import { Consultation } from "@/domain/entity/consultation/Consultation";
import { BidCreateRequest } from "@/domain/request/bid/BidCreateRequest";
import { Bid } from "@/domain/entity/bid/Bid";

@Component({})
export default class BidCreate extends Vue {
  @Prop({
    required: false,
    default: () => null,
    type: String
  })
  private readonly consultationId!: string|null;

  @Prop({
    required: false,
    default: () => [],
    type: Array
  })
  private readonly consultations!: Consultation[];

  @Prop({
    required: true,
    type: String
  })
  private readonly userId!: string;

  private selectedConsultation: Consultation|null = this.consultations.find(item => item.id === this.consultationId) || null;
  private description: string = "";

  private get price (): number {
    return this.selectedConsultation?.price || 0;
  }

  private async send (): Promise<void> {
    if (this.selectedConsultation) {
      const bid: Bid = await this.$store.dispatch('bids/create', {
        description: this.description,
        consultationId: this.selectedConsultation.id,
        userId: this.userId,
        price: this.selectedConsultation.price
      } as BidCreateRequest);
      await this.$store.dispatch('bids/payment', bid.id);
      await this.$router.push({ name: 'Bids' });
    }
  }
}

</script>

<style scoped>

</style>
